#include <bits/stdc++.h>

using namespace std;

using ll = int_fast64_t;

#define len(x) (int)(x).size()
#define int ll

void solve(){
    ll n;
    cin >> n;
    vector<ll> d(n);
    int mode;
    cin >> mode;
    if(mode == 1)
        for(auto& o: d)
            cin >> o;
    else {
        ll m, x, y, z;
        cin >> m >> x >> y >> z;
        vector<ll> c(m);
        for (auto &o: c)
            cin >> o;
        const ll mod = 1e9;
        for (int i = 0; i < n; ++i) {
            if (i < m)
                d[i] = c[i];
            else
                d[i] = ((x * d[i - 2] + y * d[i - 1] + z) % mod) + 1;
        }
    }
    stack<pair<ll, ll>> max_neg, max_no_neg;
    max_neg.emplace(-(1ll<<40), -(1ll<<40));
    max_no_neg.emplace(-(1ll<<40), -(1ll<<40));
    for (ll i = n - 1; i >= 0; --i) {
        max_no_neg.emplace(d[i] - i, max(d[i] - i, max_no_neg.top().second));
    }
    ll ans = max_no_neg.top().second, anspos = 0;
    for (int i = 0; i < n - 1; ++i) {
        ll c = max_no_neg.top().first;
        max_no_neg.pop();
        max_neg.emplace(c, max(c, max_neg.top().second));
        ll t_max = max(max_neg.top().second - n, max_no_neg.top().second);
        if(t_max + i + 1 < ans){
            ans = t_max + i + 1;
            anspos = i + 1;
        }
    }
    cout << ans << " " << anspos + 1 << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
