#include <bits/stdc++.h>
using namespace std;


using ll = int_fast64_t;

#define len(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define int ll

const ll t = 229;
const ll mod = 1e9 + 7;
vector<ll> t_pow;

ll gh(const vector<ll>& h, int begin, int end){
    return (h[end - 1] - h[begin - 1] * t_pow[end - begin] % mod + mod) % mod;
}

void solve(){
    t_pow.resize(1e6);
    t_pow[0] = 1;
    for (int i = 1; i < (int)1e6; ++i) {
        t_pow[i] = (t_pow[i - 1] * t) % mod;
    }
    int n, m;
    cin >> n >> m;
    vector<int> a(n), b(m);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    bool g2 = true;
    for (int i = 0; i < m; ++i) {
        cin >> b[i];
        if(i > 0 && b[i] != b[i - 1])
            g2 = false;
    }
    if(g2){
        vector<ll> h = a, hr = a;
        for (int i = 1; i < n; ++i) {
            h[i] = (h[i - 1] * t + h[i]) % mod;
        }
        reverse(all(hr));
        for (int i = 1; i < n; ++i) {
            hr[i] = (hr[i - 1] * t + hr[i]) % mod;
        }
        ll ans = 0;
        for (int center = 0; center < n; ++center) {
            int l = 0, r = min(center + 1, n - center + 1);
            while(l + 1 < r){
                int md = (l + r) / 2;
                if(gh(h, center - md, center) == gh(hr, n - center - md - 1, n - center - 1))
                    l = md;
                else
                    r = md;
            }
            ans = max(ans, l * 2 + 1);
            l = 0, r = min(center, n - center);
            while(l + 1 < r){
                int md = (l + r) / 2;
                if(gh(h, center - md + 1, center + 1) == gh(hr, n - center - md - 1, n - center - 1))
                    l = md;
                else
                    r = md;
            }
            ans = max(ans, l * 2);
        }
        cout << ans << "\n";
        return;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
