#include <bits/stdc++.h>

using namespace std;

using ll = int_fast64_t;

#define len(a) (int)(a).size()

ll n, q;

bool cmp(const pair<ll, ll>& a, const pair<ll, ll>& b){
    return a.first * b.second < b.first * a.second;
}

void solve(){
    cin >> n >> q;
    vector<ll> a(n);
    vector<ll> b(n);
    for(int i = 0; i < n; ++i){
        cin >> a[i];
    }
    for(int i = 0; i < n; ++i){
        cin >> b[i];
    }
    sort(a.begin(), a.end());
    sort(b.begin(), b.end());
    vector<pair<ll, ll>> s(n * n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            s[i * n + j] = {a[i], b[j]};
        }
    }
    sort(s.begin(), s.end(), &cmp);
    for (int i = 0; i < q; ++i) {
        ll c;
        cin >> c;
        --c;
        ll gcd_ = __gcd(s[c].first, s[c].second);
        cout << s[c].first / gcd_ << " " << s[c].second / gcd_ << "\n";
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
