#include <bits/stdc++.h>

using namespace std;

using ll = int_fast64_t;

#define len(a) (int)(a).size()
#define int ll

struct res{
    ll acp, ccp, ancp, cncp;
};

int n, k;
vector<vector<pair<int, ll>>> g;

res dfs(int v){
    ll acp = 1, ccp = 0, ancp = 0, cncp = 0;
    vector<res> c;
    for(auto [u, cost]: g[v])
        c.push_back(dfs(u));
    set<pair<ll, int>> aicp;
    set<pair<ll, int>> anicp;
    for (int u = 0; u < len(g[v]); ++u) {
        if(c[u].acp > c[u].ancp)
            aicp.insert({g[v][u].second, u});
        else
            anicp.insert({g[v][u].second - (c[u].cncp - c[u].ccp), u});
    }
    int i = 0, in = 0;
    for(auto [cost, u]: aicp){
        if(i < k - 1){
            acp += c[u].acp;
            ccp += c[u].ccp;
            ccp += cost;
            ++i;
        }else{
            acp += c[u].ancp;
            ccp += c[u].cncp;
        }
        if(in < k){
            ancp += c[u].acp;
            cncp += c[u].ccp;
            cncp += cost;
            ++in;
        }else {
            ancp += c[u].ancp;
            cncp += c[u].cncp;
        }
    }
    for(auto [value, u] : anicp){
        if(i < k - 1 && value < 0){
            acp += c[u].acp;
            ccp += c[u].ccp;
            ccp += g[v][u].second;
            ++i;
        }else{
            acp += c[u].ancp;
            ccp += c[u].cncp;
        }
        if(in < k && value < 0){
            ancp += c[u].acp;
            cncp += c[u].ccp;
            cncp += g[v][u].second;
            ++in;
        }else{
            ancp += c[u].ancp;
            cncp += c[u].cncp;
        }
    }
    return {acp, ccp, ancp, cncp};
}

void solve(){
    cin >> n >> k;
    g.resize(n);
    for (int i = 1; i < n; ++i) {
        int p;
        ll w;
        cin >> p >> w;
        --p;
        g[p].emplace_back(i, w);
    }
    res r = dfs(0);
    cout << r.ancp << " " << r.cncp << "\n";
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
