#include <bits/stdc++.h>

using namespace std;

using ll = int_fast64_t;

#define len(a) (int)(a).size()

ll n, q;

pair<ll, ll> block_num(ll i){
    if (i < n * (n + 1) / 2){
        ll l = 0, r = n;
        while (l + 1 < r){
            ll m = (l + r) / 2;
            if (i < m * (m + 1) / 2)
                r = m;
            else
                l = m;
        }
        return {l, i - l * (l + 1) / 2};
    }else{
        ll l = 0, r = n;
        while (l + 1 < r){
            ll m = (l + r) / 2;
            if (i < n * n - (n - m) * (n - m - 1) / 2)
                r = m;
            else
                l = m;
        }
        return {l + n, i - n * n + (n - l) * (n - l - 1) / 2};
    }
}

bool cmp(const pair<ll, ll>& a, const pair<ll, ll>& b){
    return a.first * b.second < b.first * a.second;
}

void solve(){
    cin >> n >> q;
    vector<ll> a(n);
    vector<ll> b(n);
    vector<pair<ll, int>> c(q);
    for(int i = 0; i < n; ++i){
        cin >> a[i];
    }
    for(int i = 0; i < n; ++i){
        cin >> b[i];
    }
    for(int i = 0; i < q; ++i){
        cin >> c[i].first;
        --c[i].first;
        c[i].second = i;
    }
    sort(a.begin(), a.end());
    sort(b.begin(), b.end());
    sort(c.begin(), c.end());
    vector<pair<ll, ll>> ans(q);
    vector<pair<ll, ll>> cur_block;
    cur_block.reserve(n);
    ll prev_block_num = -1;
    for(int i = 0; i < q; ++i){
        auto t = block_num(c[i].first);
        ll cur_block_num = t.first, pos = t.second;
        if (cur_block_num != prev_block_num){
            cur_block.clear();
            for(int j = max(0ll, (cur_block_num - n + 1)); j < min(n, n + (cur_block_num - n + 1)); ++j){
                cur_block.emplace_back(a[j], b[j - (cur_block_num - n + 1)]);
            }
            sort(cur_block.begin(), cur_block.end(), &cmp);
            prev_block_num = cur_block_num;
        }
        ll gcd_ = __gcd(cur_block[pos].first, cur_block[pos].second);
        ans[c[i].second] = {cur_block[pos].first / gcd_, cur_block[pos].second / gcd_};
    }
    for(auto& o : ans)
        cout << o.first << " " << o.second << "\n";
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
