#include <bits/stdc++.h>

using namespace std;

using ll = int_fast64_t;

#define len(a) (int)(a).size()

ll n, q;

bool cmp(const pair<ll, ll>& a, const pair<ll, ll>& b){
    return a.first * b.second < b.first * a.second;
}

void solve(){
    cin >> n >> q;
    vector<ll> a(n);
    vector<ll> b(n);
    vector<ll> c(q);
    for(int i = 0; i < n; ++i){
        cin >> a[i];
    }
    for(int i = 0; i < n; ++i){
        cin >> b[i];
    }
    ll maxc = 0;
    for (int i = 0; i < q; ++i) {
        cin >> c[i];
        --c[i];
        maxc = max(maxc, c[i]);
    }
    sort(a.begin(), a.end());
    sort(b.begin(), b.end());
    if(maxc <= 1000){
        n = min(n, (ll)1000);
        a.resize(n);
        vector<ll> b_new;
        for (ll i = n - 1000; i < n; ++i) {
            b_new.push_back(b[i]);
        }
        b = b_new;
    }
    vector<pair<ll, ll>> s(n * n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            s[i * n + j] = {a[i], b[j]};
        }
    }
    sort(s.begin(), s.end(), &cmp);
    for (auto ci: c) {
        ll gcd_ = __gcd(s[ci].first, s[ci].second);
        cout << s[ci].first / gcd_ << " " << s[ci].second / gcd_ << "\n";
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
